# Note that this is NOT a relocatable package
%define libmaj	0
%define libmin	9
%define librel	6
%define rel	3kr

Summary: Open source implementation of SSL and TLS
Summary(ko): SSL TLS   Open Source
Name: openssl
Version: %{libmaj}.%{libmin}.%{librel}i
Release: %rel
Copyright: Freely distributable
Group: System Environment/Libraries
Source0: http://www.openssl.org/source/openssl-%{version}.tar.gz
Source1: Makefile.cert
Patch0: openssl-CA.pl.diff
Patch1: openssl-i686.patch
Patch2: openssl-64bit.patch
Patch3: openssl-glibc.patch
Patch4: openssl-x509.patch
# security patch
Patch100: openssl-timing-based-attack.patch
Patch101: openssl-bleichenbacher-acttack.patch
Patch102: openssl-asn1-parse-attack.patch
BuildRoot: /var/tmp/openssl
URL: http://www.openssl.org
Docdir: /usr/share/doc

%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide.

%description -l ko
OpenSSL Ʈ ߰ϰ  ǰ  ǰ ߰ ǳ 
  ҽ Ŷμ   (SSL v2/v3)   (TLS v1)
 ϰ ִ.

%package devel
Summary: OpenSSL libraries and development headers.
Group: Documentation
Requires: openssl

%description devel
The static libraries and include files needed to compile apps
with support for various cryptographic algorithms and protocols.

Patches for many networking apps can be found at:
ftp://ftp.psy.uq.oz.au/pub/Crypto/SSLapps/

%description -l ko devel
 ȣȭ ˰  ϴ ø̼ǵ
 ϴµ ʿ  ̺귯 ϵ

 Ʈŷ α׷  ġ
ftp://ftp.psy.uq.oz.au/pub/Crypto/SSLapps/  Ҽ ִ.


%package doc
Summary: OpenSSL miscellaneous files
Summary(ko): OpenSSL   ϵ
Group: Documentation
Requires: openssl

%description doc
OpenSSL documents

%description -l ko doc
OpenSSL 

%prep
%setup -q
%patch0 -p1 -b .org
%ifarch i686
%patch1 -p1 -b .org
%endif
%patch2 -p1 -b .org
%patch3 -p1 -b .org
%patch4 -p1 -b .org

%patch100 -p1
%patch101 -p1
%patch102 -p1

%build
C_FLAGS=-DSSL_ALLOW_ADH
./Configure $C_FLAGS --prefix=/usr --openssldir=%{_datadir}/ssl linux-elf shared
LD_LIBRARY_PATH=`pwd` make
LD_LIBRARY_PATH=`pwd` make rehash

%install
rm -rf $RPM_BUILD_ROOT
make INSTALL_PREFIX=$RPM_BUILD_ROOT install

# Install RSAref stuff
install -m644 rsaref/rsaref.h $RPM_BUILD_ROOT/usr/include/openssl
install -m644 libRSAglue.a $RPM_BUILD_ROOT%{_libdir}

# Make backwards-compatibility symlink to ssleay
ln -s /usr/bin/openssl $RPM_BUILD_ROOT/usr/bin/ssleay

# Install shared libs
install -m644 libcrypto.a $RPM_BUILD_ROOT%{_libdir}
install -m755 libcrypto.so.%{libmaj}.%{libmin}.%{librel} $RPM_BUILD_ROOT%{_libdir}
install -m644 libssl.a $RPM_BUILD_ROOT%{_libdir}
install -m755 libssl.so.%{libmaj}.%{libmin}.%{librel} $RPM_BUILD_ROOT%{_libdir}
(
	cd $RPM_BUILD_ROOT%{_libdir}
	ln -sf libcrypto.so.%{libmaj}.%{libmin}.%{librel} libcrypto.so.%{libmaj}
	ln -sf libcrypto.so.%{libmaj}.%{libmin}.%{librel} libcrypto.so
	ln -sf libssl.so.%{libmaj}.%{libmin}.%{librel} libssl.so.%{libmaj}
	ln -sf libssl.so.%{libmaj}.%{libmin}.%{librel} libssl.so
)

install -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/ssl/certs/Makefile

# move man page
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/{man1,man3,man5,man7}
mv $RPM_BUILD_ROOT%{_datadir}/ssl/man/man1/* $RPM_BUILD_ROOT/%{_mandir}/man1/
mv $RPM_BUILD_ROOT%{_datadir}/ssl/man/man3/* $RPM_BUILD_ROOT/%{_mandir}/man3/
mv $RPM_BUILD_ROOT%{_datadir}/ssl/man/man5/* $RPM_BUILD_ROOT/%{_mandir}/man5/
mv $RPM_BUILD_ROOT%{_datadir}/ssl/man/man7/* $RPM_BUILD_ROOT/%{_mandir}/man7/
rm -rf $RPM_BUILD_ROOT%{_datadir}/ssl/man

# permission change for security
chmod 750 $RPM_BUILD_ROOT%{_datadir}/ssl/private

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
/usr/bin/*
%{_datadir}/ssl
%{_libdir}/libcrypto.so.%{libmaj}.%{libmin}.%{librel}
%{_libdir}/libssl.so.%{libmaj}.%{libmin}.%{librel}

%files devel
/usr/include/openssl
%{_libdir}/*.a
%{_libdir}/libcrypto.so.%{libmaj}
%{_libdir}/libssl.so.%{libmaj}
%{_libdir}/libcrypto.so
%{_libdir}/libssl.so

%files doc
%{_mandir}/*/*
%doc README INSTALL.* CHANGE* LICENSE NEWS doc demos

%post
/sbin/ldconfig

if [ -d /var/ssl ]; then
  cp -af /var/ssl/* /usr/share/ssl > /dev/null 2>&1
  rm -rf /var/ssl > /dev/null 2>&1
fi

if [ -d /usr/ssl ]; then
  cp -af /usr/ssl/* /usr/share/ssl > /dev/null 2>&1
  rm -rf /usr/ssl > /dev/null 2>&1
fi

%postun
/sbin/ldconfig

CHECK1=$(/bin/ls -l /var/ssl 2> /dev/null | awk '{print $1}')
CHECK2=$(/bin/ls -l /usr/ssl 2> /dev/null | awk '{print $1}')

if [ "$CHECK1" = "lrwxrwxrwx" ]; then
  /bin/rm -rf /var/ssl > /dev/null 2>&1
fi

if [ "$CHECK2" = "lrwxrwxrwx" ]; then
  /bin/rm -rf /usr/ssl > /dev/null 2>&1
fi

%changelog
* Wed Oct  1 2003 JoungKyun Kim <http://www.oops.org> 0.9.6i-3kr
- patched asn1 parsing attack bug

* Sat Mar 22 2003 JoungKyun Kim <http://www.oops.org> 0.9.6i-2kr
- added openssl-bleichenbacher-acttack.patch
- added openssl-timing-based-attack.patch

* Sat Feb 22 2003 JoungKyun Kim <http://www.oops.org>
- update 0.9.6i
- added glibc patch
- added 64bit patch
- added x509 patch

* Sat Dec 19 2002 JoungKyun Kim <http://www.oops.org>
- update 0.9.6h

* Sat Aug 17 2002 JoungKyun Kim <http://www.oops.org>
- update 0.9.6g

* Thu Aug  1 2002 JoungKyun Kim <http://www.oops.org>
- update 0.9.6e

* Wed Jun 25 2002 JoungKyun Kim <http://www.oops.org>
- update 0.9.6d

* Mon Dec 24 2001 JoungKyun Kim <http://www.oops.org>
- update 0.9.6c

* Fri Aug 10 2001 JoungKyun Kim <http://www.oops.org>
- update 0.9.6b

* Thu Jun 14 2001 JoungKyun Kim <http://www.oops.org>
- moved directory struture in RH style

* Sat Apr  7 2001 JoungKyun Kim <http://www.oops.org>
- update 0.9.6a
- if /var/ssl or /usr/share/ssl, moved all files
  and directoris in that directoy to /usr/ssl

* Thu Mar  1 2001 JoungKyun Kim <http://www.oops.org>
- update 0.9.6
- added softlink /var/ssl and /usr/share/ssl
- added openssl doc package

* Wed Aug  9 2000 JoungKyun Kim <http://www.oops.org>
- moved man page in REDHAT Type
- openssl directory permission change for security
- added shared library
- added RSAref stuff
- added ssleay symlink with backwards-compatibility

* Sun Apr  2 2000 JountKyun Kim <http://www.oops.org>
- changed openssl dir
- upgraded to 0.9.5a

